org.apache.commons.io.input

## Class ReaderInputStream.Builder

- java.lang.Object
- - org.apache.commons.io.build.AbstractSupplier<T,B>
  - - org.apache.commons.io.build.AbstractOriginSupplier<T,B>
    - - org.apache.commons.io.build.AbstractStreamBuilder<ReaderInputStream,ReaderInputStream.Builder>
      - - org.apache.commons.io.input.ReaderInputStream.Builder

- All Implemented Interfaces:
    IOSupplier<ReaderInputStream>
  Enclosing class:
    ReaderInputStream

      public static class ReaderInputStream.Builder
      extends AbstractStreamBuilder<ReaderInputStream,ReaderInputStream.Builder>

  Constructs a new `ReaderInputStream` with a default input buffer size of `IOUtils.DEFAULT_BUFFER_SIZE` characters.

  For example:

       ReaderInputStream s = ReaderInputStream.builder()
         .setPath(path)
         .setCharsetEncoder(Charset.defaultCharset().newEncoder())
         .get();

  See Also:
    `get()`

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `Builder()` Constructs a new builder of `ReaderInputStream`.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `ReaderInputStream` | `get()` Builds a new `ReaderInputStream`.
    `(package private) CharsetEncoder` | `getCharsetEncoder()`
    `ReaderInputStream.Builder` | `setCharset(Charset charset)` Sets the Charset.
    `ReaderInputStream.Builder` | `setCharsetEncoder(CharsetEncoder newEncoder)` Sets the charset encoder.

    - ### Methods inherited from class org.apache.commons.io.build.AbstractStreamBuilder

      `getBufferSize, getBufferSizeDefault, getCharSequence, getCharset, getCharsetDefault, getFile, getInputStream, getOpenOptions, getOutputStream, getPath, getRandomAccessFile, getReader, getWriter, setBufferSize, setBufferSize, setBufferSizeChecker, setBufferSizeDefault, setBufferSizeMax, setCharset, setCharsetDefault, setOpenOptions`

    - ### Methods inherited from class org.apache.commons.io.build.AbstractOriginSupplier

      `checkOrigin, getOrigin, hasOrigin, newByteArrayOrigin, newCharSequenceOrigin, newFileOrigin, newFileOrigin, newInputStreamOrigin, newOutputStreamOrigin, newPathOrigin, newPathOrigin, newRandomAccessFileOrigin, newRandomAccessFileOrigin, newReaderOrigin, newURIOrigin, newWriterOrigin, setByteArray, setCharSequence, setFile, setFile, setInputStream, setOrigin, setOutputStream, setPath, setPath, setRandomAccessFile, setRandomAccessFile, setReader, setURI, setWriter`

    - ### Methods inherited from class org.apache.commons.io.build.AbstractSupplier

      `asThis`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.apache.commons.io.function.IOSupplier

      `asSupplier, getUnchecked`

- - ### Constructor Detail

    - #### Builder

          public Builder()

      Constructs a new builder of `ReaderInputStream`.

  - ### Method Detail

    - #### get

          public ReaderInputStream get()
                                throws IOException

      Builds a new `ReaderInputStream`.

      You must set an aspect that supports `AbstractStreamBuilder.getReader()`, otherwise, this method throws an exception.

      This builder uses the following aspects:

      - `AbstractStreamBuilder.getReader()` gets the target aspect.
      - `AbstractStreamBuilder.getBufferSize()`
      - `AbstractStreamBuilder.getCharset()`
      - `CharsetEncoder`
      Returns:
        a new instance.
      Throws:
        `UnsupportedOperationException` - if the origin cannot provide a `Reader`.
        `IllegalStateException` - if the `origin` is `null`.
        `IOException` - if an I/O error occurs converting to a `Reader` using `AbstractStreamBuilder.getReader()`.
      See Also:
        `AbstractStreamBuilder.getReader()`, `CharsetEncoder`, `AbstractStreamBuilder.getBufferSize()`, `IOSupplier.getUnchecked()`

    - #### getCharsetEncoder

          CharsetEncoder getCharsetEncoder()

    - #### setCharset

          public ReaderInputStream.Builder setCharset(Charset charset)

      Description copied from class: `AbstractStreamBuilder`
      Sets the Charset.

      Subclasses may ignore this setting.

      Overrides:
        `setCharset` in class `AbstractStreamBuilder<ReaderInputStream,ReaderInputStream.Builder>`
      Parameters:
        `charset` - the Charset, null resets to the default.
      Returns:
        `this` instance.

    - #### setCharsetEncoder

          public ReaderInputStream.Builder setCharsetEncoder(CharsetEncoder newEncoder)

      Sets the charset encoder. Assumes that the caller has configured the encoder.
      Parameters:
        `newEncoder` - the charset encoder, null resets to a default encoder.
      Returns:
        `this` instance.